<?
/*
This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been write by Olivier.LeCam@crdp.ac-versailles.fr
Ce script  t crit par Olivier.LeCam@crdp.ac-versailles.fr

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/

/********************************************************************************
 olecam, june 8, 2003
   - fixed a link problem in navigation arrows of the user administration page
   - $PHP_SELF is not global and was not working properly. Replaced by $_SERVER['PHP_SELF']
 ********************************************************************************/

function MAIL_FILTER_makeTitle($text)
{
        $title  = "<table bgcolor='#0000BB' width='100%'><tr><td><b><font color='white' size='2'>\n";
        $title .= $text."\n";
        $title .= "</font></b></td></tr></table>\n";

        return $title;
}

////////////////////////////////////////////////////////////////////////////////
// Add a rule in pgsql

function MAIL_FILTER_addRule($db, $val, $rule)
{
        $query = sprintf("INSERT INTO mail_filter (val_opt,rule) VALUES ('%s','%s')",
                addslashes($val),
                addslashes($rule));
        pg_exec($db, $query);         
                                                          
        $rule = str_replace(".", "\.", $rule);
        $rule = str_replace("^", "\^", $rule);
        $rule = str_replace("$", "\$", $rule);        
        $rule = str_replace("*", ".*", $rule);
        $rule = "^<?".$rule.">?$";

        $query = sprintf("INSERT INTO mail_filter_regex (val_opt,regex_rule) VALUES ('%s','%s')",
                addslashes($val),
                addslashes($rule));
        pg_exec($db, $query);
}


////////////////////////////////////////////////////////////////////////////////
// Delete the current rules from the pgsql

function MAIL_FILTER_deleteCurrentRules($db)
{
        $query = "DELETE FROM mail_filter";
        pg_exec($db, $query);
        
        $query = "DELETE FROM mail_filter_regex";
        pg_exec($db, $query);
}

////////////////////////////////////////////////////////////////////////////////
// Show the mail filter rules

function MAIL_FILTER_showRules($db)
{
        include("../../slis.conf.php");
        include("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
        $http_code = '';

        // Get the filtering rules from the pg sql
        $query = "SELECT * FROM mail_filter ORDER BY val_opt;";
        $result = pg_exec($db, $query);
        $num = pg_numrows($result);

        // Show the rules in a form
        $http_code .= "<form name='mail_filter' method='post' action=".$_SERVER['PHP_SELF'].">\n";
        $http_code .= "<table border='0'>\n";

        // Column titles
        $http_code .= "<tr>\n";
        $http_code .= "  <td><font size='2'><b>$lang_MailFilter_RuleName</b></font></td>\n";
        $http_code .= "  <td><font size='2'><b>$lang_MailFilter_Rule</b></font></td>\n";
        $http_code .= "</tr>\n";

        // Rules
        for($i = 0; $i < $num; $i++) {
                $arr = pg_fetch_array($result, $i);
                
                $value = $arr['val_opt'];
                $rule  = $arr['rule'];

                $http_code .= "<tr>\n";
                if( $value == 'intranet' || $value == 'extranet' ) {
                        $http_code .= "  <td bgcolor='#BBBBBB'>$value</td>\n";
                        $http_code .= "  <td bgcolor='#BBBBBB'>$rule</td>\n";
                        $http_code .= "<input type='hidden' name='val".$i."' value='$value'>\n";
                        $http_code .= "<input type='hidden' name='rule".$i."' value='$rule'>\n";
                } else {
                        $http_code .= "  <td><input type='text' name='val".$i."' value='$value' size='20' maxlength='20'></td>\n";
                        $http_code .= "  <td><input type='text' name='rule".$i."' value='$rule' size='60' maxlength='255'></td>\n";
                }
                $http_code .= "</tr>\n";
        }

        // Add a new rule
        if( $num ) {
                $http_code .= "<tr><td colspan='2'><br>\n";
                $http_code .= "<font size='2'><b>$lang_MailFilter_AddARule</b>\n";
                $http_code .= "</font></td></tr>\n";
        }
        $http_code .= "<tr>\n";
        $http_code .= "  <td><input type='text' name='val".$i."' value='' size='20' maxlength='20'></td>\n";
        $http_code .= "  <td><input type='text' name='rule".$i."' value='' size='60' maxlength='255'></td>\n";
        $http_code .= "</tr>\n";

        $http_code .= "</table>\n";

        // Validate button
        $http_code .= "<center><input type='submit' value='$lang_MailFilter_validate' name='validate'></center>\n";

        $http_code .= "</form>\n";

        return $http_code;
}

////////////////////////////////////////////////////////////////////////////////
// Get the mail rule filter name associated with the specified user
// That info is stored in table hadmin.option_users (val_opt = "mail_filter")

function MAIL_FILTER_getRulesName($db, $userid)
{
        $query = sprintf("SELECT val_opt FROM options_users WHERE type_opt='mail_filter' AND userid=%d",
                $userid);
        $result = pg_exec($db, $query);

        // No rule specified for that user
        if( pg_numrows($result) == 0 )
                return '';

        $row = pg_fetch_row($result, 0);
        return $row[0];         // return val_opt
}

////////////////////////////////////////////////////////////////////////////////
// How much records are available in the user table ?

function MAIL_FILTER_getUserCount($db)
{
        $query = "SELECT COUNT(id) FROM users WHERE login<>'ldapadm'";
        $result = pg_exec($db, $query);
        $row = pg_fetch_row($result, 0);
        return $row[0];
}

////////////////////////////////////////////////////////////////////////////////
// Show the mail filter rules

function MAIL_FILTER_showUsers($db, $offset, $filter, $filter_type, $isExpertMode)
{
        include("../../slis.conf.php");
        include("../inc/lang/$LANGUAGE.inc.php");

        $user_count = MAIL_FILTER_GetUserCount($db);
        if( $offset < 0 || $offset > $user_count )
                $offset=0;              
                
        $http_code  = MAIL_FILTER_makeTitle($lang_MailUsers_RuleAjust);

        $http_code .= "<form name='mail_filter' method='post' action=".$_SERVER['PHP_SELF'].">\n";

        // Filters     
        $http_code .= "<center>\n";
        $http_code .= "<font size='2'><b>\n";
        $http_code .= "$lang_MailUsers_search: <input type='text' name='filter' value='$filter'>\n";
        $http_code .= "$lang_MailUsers_in\n";
        $http_code .= "<select name='filter_type'>\n";
        $http_code .= "  <option  value='0'" . ($filter_type == 0 ? 'selected' : '') . ">$lang_MailUsers_FirstName</option>\n";
        $http_code .= "  <option  value='1'" . ($filter_type == 1 ? 'selected' : '') . ">$lang_MailUsers_LastName</option>\n";
        $http_code .= "  <option  value='2'" . ($filter_type == 2 ? 'selected' : '') . ">$lang_Login</option>\n";
//        $http_code .= "  <option  value='3'" . ($filter_type == 3 ? 'selected' : '') . ">$lang_Group</option>\n";
        $http_code .= "</select>\n";
        $http_code .= "</b></font>\n";
        $http_code .= "<input type='submit' value='$lang_MailFilter_validate'>\n";
        $http_code .= "</center>\n";

        $http_code .= "<table border=0 cellpadding=1 bgcolor='#FFFFFF' width='100%'>";

        // Column titles
        $http_code .= "<tr bgcolor='#EEEEFF'>\n";
        $http_code .= "  <td><font size='2'><b>$lang_MailUsers_LastName</b></font></td>\n";
        $http_code .= "  <td><font size='2'><b>$lang_MailUsers_FirstName</b></font></td>\n";
        $http_code .= "  <td><font size='2'><b>$lang_Login</b></font></td>\n";
        $http_code .= "  <td><font size='2'><b>$lang_MailUsers_RuleName</b></font></td>\n";
//        $http_code .= "  <td><font size='2'><b>$lang_Group</b></font></td>\n";
        $http_code .= "</tr>\n";
                                  
/* the following code is keeped for a futur feature
        // Group name for every id
        $query  = "SELECT id,nom FROM classes ORDER BY id";
        $result = pg_exec($db, $query);
        $num = pg_numrows($result);
        for($i; $i < $num, $i++) {
                $arr = pg_fetch_array($result, $i);
                $groupid2name[$arr['id']] = $arr['nom'];
        }
*/

        // Get the filtering rules from the pg sql
        if( $filter ) {
                $filter = strtoupper($filter);
                if( $filter_type == 0 ) {
                        $having = sprintf("AND UPPER(prenom) LIKE '%%%s%%'", $filter);
                } else if( $filter_type == 1 ) {
                        $having = sprintf("AND UPPER(nom) LIKE '%%%s%%' ", $filter);
                } else if( $filter_type == 2 ) {
                        $having = sprintf("AND UPPER(login) LIKE '%%%s%%' ", $filter);
                }
        }
        $query = sprintf("SELECT id,prenom,nom,login FROM users WHERE login<>'ldapadm' %s ORDER BY nom LIMIT 20,%d",
                $having,
                $offset);

        $result = pg_exec($db, $query);
        $num = pg_numrows($result);

        // Retrieve rule names for the users from the database
        for($i = 0; $i < $num; $i++) {
                $arr = pg_fetch_array($result, $i);
                $rule_name = MAIL_FILTER_getRulesName($db, $arr['id']);

                $http_code .= "<tr bgcolor='#EEEEFF'>\n";
                $http_code .= "  <td>".$arr['nom']."</td>\n";
                $http_code .= "  <td>".$arr['prenom']."</td>\n";
                $http_code .= "  <td>".$arr['login']."</td>\n";
                if( $isExpertMode ) {
                        $http_code .= "  <td><input type='text' size='30' maxlength='30' value='".$rule_name."' name='userid_".$arr['id']."'></td>\n";
                } else { 
                        $intranet_isselected = ($rule_name == 'intranet') ? 'selected' : '';
                        $extranet_isselected = ($rule_name == 'extranet') ? 'selected' : '';
                        $http_code .= "<td>\n";
                        $http_code .= "<select name='userid_".$arr['id']."'>\n";
                        $http_code .= "  <option value='intranet'$intranet_isselected>intranet</option>\n";
                        $http_code .= "  <option value='extranet'$extranet_isselected>extranet</option>\n";
                        if( $rule_name != 'intranet' && $rule_name != 'extranet' ) {
                                $value = $rule_name == '' ? '---' : $rule_name;
                                $http_code .= "  <option value='$value' selected>$value</option>\n";
                        }
                        $http_code .= "</select>\n";
                        $http_code .= "</td>\n";
                }
                $http_code .= "</tr>\n";

                $userid_list .= $arr['id']." ";
        }

        $http_code .= "</table>\n";

        // Validation table and links to browse the list
        DEFINE(PAGE_SIZE, 20);  // Max number of row by page
        $begin  = 0;
        $end    = $user_count > PAGE_SIZE ? $user_count - PAGE_SIZE : 0;
        $before = $offset > PAGE_SIZE ? $offset - PAGE_SIZE : 0;
        $next   = $offset < $end ? $offset + PAGE_SIZE : $end;

        $http_code .= "<table border='0' width='100%'>\n";
        $http_code .= "<tr>\n";
        $http_code .= "  <td align='center'>\n";
        $http_code .= "    <input type='submit' value='$lang_MailFilter_validate' name='update_rules'>\n";
        $http_code .= "  </td>\n";
        $http_code .= "</tr><tr>\n";
        $http_code .= "  <td align='right'>\n";
		if ($offset) {
			$left_img  = '../images/left_on.gif';
        	$http_code .= "    <a href=".$_SERVER['PHP_SELF']."?offset=$begin><img src='$left_img' border=0><img src='$left_img' border=0></a>&nbsp;\n";
        	$http_code .= "    <a href=".$_SERVER['PHP_SELF']."?offset=$before><img src='$left_img' border=0></a>&nbsp;&nbsp;&nbsp;&nbsp;\n";
		} else {
			$left_img  = '../images/left_off.gif';
        	$http_code .= "    <img src='$left_img' border=0><img src='$left_img' border=0>&nbsp;\n";
        	$http_code .= "    <img src='$left_img' border=0>&nbsp;&nbsp;&nbsp;&nbsp;\n";
		}
		if ($offset < $end) {
		    $right_img = '../images/right_on.gif';
        	$http_code .= "    <a href=".$_SERVER['PHP_SELF']."?offset=$next><img src='$right_img' border=0></a>&nbsp;\n";
        	$http_code .= "    <a href=".$_SERVER['PHP_SELF']."?offset=$end><img src='$right_img' border=0><img src='$right_img' border=0></a>\n";
		} else {
		    $right_img = '../images/right_off.gif';
        	$http_code .= "    <img src='$right_img' border=0>&nbsp;\n";
        	$http_code .= "    <img src='$right_img' border=0><img src='$right_img' border=0>\n";
		}
        $http_code .= "     &nbsp;&nbsp;&nbsp;\n";
        $http_code .= "  </td>\n";
        $http_code .= "</tr>\n";
        $http_code .= "</table>\n";
        $http_code .= "<input type='hidden' name='userid_list' value='$userid_list'>\n";
        $http_code .= "</form>\n";

        // Setting a rule for a group of users
        $http_code .= MAIL_FILTER_makeTitle($lang_MailUsers_RuleSettingForGroup);
        $http_code .= "<form name='group_setting' method='post' action=".$_SERVER['PHP_SELF'].">\n";
        $http_code .= "<table border=0>\n";
        $http_code .= "<tr>\n";
        $http_code .= "<td><font size='2'><b>$lang_MailUsers_RuleName&nbsp;:&nbsp</font></td>\n";
        if( $isExpertMode ) {
                $http_code .= "<td><input type='text' size='30' maxlength='30' value='' name='group_rule'></td>\n";
        } else {
                $http_code .= "<td>\n";
                $http_code .= "<select name='group_rule'>\n";
                $http_code .= "  <option value='intranet'>intranet</option>\n";
                $http_code .= "  <option value='extranet'>extranet</option>\n";
                $http_code .= "</select>\n";
                $http_code .= "</td>\n";
        }
        $http_code .= "</tr>\n";

        $http_code .= "<tr>\n";
        $http_code .= "<td><font size='2'><b>$lang_MailUsers_GroupToApply&nbsp;:&nbsp</font></td>\n";
        $http_code .= "<td>\n";
        $http_code .= "<select name='group_id'>\n";

        $query = "SELECT id,nom FROM classes ORDER BY nom";
        $http_code .= "  <option  value='-1'>$lang_MailUsers_All</option>\n";
        $result = pg_exec($db, $query);
        $num = pg_numrows($result);

        // Retrieve rule names for the users from the database
        for($i = 0; $i < $num; $i++) {
                $arr = pg_fetch_array($result, $i);
                $group_id   = $arr['id'];
                $group_name = $arr['nom'];
                $http_code .= "  <option  value='$group_id'>$group_name</option>\n";
        }
        $http_code .= "</select>\n";
        $http_code .= "</td>\n";
        $http_code .= "</tr>\n";
//        $http_code .= "<tr><td align='center' colspan='2'>\n";
//        $http_code .= "</td></tr>\n";
        $http_code .= "</table>\n";
        $http_code .= "<table border='0' width='100%'><tr><td align='center'>\n";
        $http_code .= "<input type='submit' value='$lang_MailFilter_apply' name='apply_to_group'>\n";
        $http_code .= "</td></tr></table>\n";
        $http_code .= "</form>\n";
                                   
        // Expert versus Novice mode
        $http_code .= MAIL_FILTER_makeTitle($lang_MailUsers_AdminMode);
        if( $isExpertMode ) {
                $current_mode = $lang_MailExpertMode;
                $switch_to    = $lang_MailNoviceMode;
        } else {
                $current_mode = $lang_MailNoviceMode;
                $switch_to    = $lang_MailExpertMode;
        }
        $http_code .= "<center>\n";
        $http_code .= "$lang_MailActiveMode $current_mode.<br>\n";
        $http_code .= "<form name='mode' method='post' action=".$_SERVER['PHP_SELF'].">\n";
        $http_code .= "<input type='submit' name='change_mode' value='$lang_MailSwitchToMode $switch_to'>\n";
        $http_code .= "</form>\n";
        $http_code .= "</center>\n";

        return $http_code;
}
